Package: swagger
Type: Package
Title: Dynamically Generates Documentation from a 'Swagger' Compliant
        API
Version: 5.32.1
Authors@R: c(
    person("Barret", "Schloerke", role = "aut", email = "barret@rstudio.com", comment = c(ORCID = "0000-0001-9986-114X")),
    person("Javier", "Luraschi", role = "aut", email = "javier@rstudio.com"),
    person("Bruno", "Tremblay", role = c("cre", "ctb"), email = "cran@neoxone.com"),
    person(family = "RStudio", role = "cph"),
    person(family = "SmartBear Software", role = c("aut", "cph"))
    )
Suggests: jsonlite, plumber, testthat
Description: A collection of 'HTML', 'JavaScript', and 'CSS' assets that
  dynamically generate beautiful documentation from a 'Swagger' compliant API:
  <https://swagger.io/specification/>.
License: Apache License 2.0 | file LICENSE
Encoding: UTF-8
URL: https://rstudio.github.io/swagger/,
        https://github.com/rstudio/swagger
BugReports: https://github.com/rstudio/swagger/issues
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-03-27 15:27:27 UTC; bruno
Author: Barret Schloerke [aut] (ORCID: <https://orcid.org/0000-0001-9986-114X>),
  Javier Luraschi [aut],
  Bruno Tremblay [cre, ctb],
  RStudio [cph],
  SmartBear Software [aut, cph]
Maintainer: Bruno Tremblay <cran@neoxone.com>
Repository: CRAN
Date/Publication: 2026-03-28 06:10:24 UTC
Built: R 4.6.0; ; 2026-04-25 16:31:13 UTC; unix

Package: swagger
Type: Package
Title: Dynamically Generates Documentation from a 'Swagger' Compliant
        API
Version: 5.32.1
Authors@R: c(
    person("Barret", "Schloerke", role = "aut", email = "barret@rstudio.com", comment = c(ORCID = "0000-0001-9986-114X")),
    person("Javier", "Luraschi", role = "aut", email = "javier@rstudio.com"),
    person("Bruno", "Tremblay", role = c("cre", "ctb"), email = "cran@neoxone.com"),
    person(family = "RStudio", role = "cph"),
    person(family = "SmartBear Software", role = c("aut", "cph"))
    )
Suggests: jsonlite, plumber, testthat
Description: A collection of 'HTML', 'JavaScript', and 'CSS' assets that
  dynamically generate beautiful documentation from a 'Swagger' compliant API:
  <https://swagger.io/specification/>.
License: Apache License 2.0 | file LICENSE
Encoding: UTF-8
URL: https://rstudio.github.io/swagger/,
        https://github.com/rstudio/swagger
BugReports: https://github.com/rstudio/swagger/issues
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-03-27 15:27:27 UTC; bruno
Author: Barret Schloerke [aut] (ORCID: <https://orcid.org/0000-0001-9986-114X>),
  Javier Luraschi [aut],
  Bruno Tremblay [cre, ctb],
  RStudio [cph],
  SmartBear Software [aut, cph]
Maintainer: Bruno Tremblay <cran@neoxone.com>
Repository: CRAN
Date/Publication: 2026-03-28 06:10:24 UTC
Built: R 4.6.0; ; 2026-04-26 11:16:08 UTC; unix

# swagger-rs

[![Build Status](https://travis-ci.org/Metaswitch/swagger-rs.svg?branch=master)](https://travis-ci.org/Metaswitch/swagger-rs)
[![crates.io](https://img.shields.io/crates/v/swagger.svg)](https://crates.io/crates/swagger)

A set of common utilities for crates generated by the `rust-server` [openapi-generator](https://github.com/OpenAPITools/openapi-generator) generator

# Releasing a new version

1. Run `./release-changelog.sh <version>` to update the changelog and `Cargo.toml`
2. Commit and push your changes.
3. Wait for a travis build to complete successfully.
4. Run `cargo publish`.
5. Tag the new version and push the tag.

#' Plumber `register_doc()` information
#'
#' Normally documentation is registered in the `.onLoad()` method of the package.
#' To avoid a circular dependency with `swagger` when `plumber` are starting up,
#' `plumber` must retrieve this information manually on it's startup.
#'
#' See the examples for how documentation should regularly be registered.
#'
#' @keywords internal
#' @export
#' @examples
#' \dontrun{
#' ## Suggested setup for other packages trying to register visual docs for plumber
#' .onLoad <- function(...) {
#'   plumber_register_ui <- function() {
#'     tryCatch({
#'       do.call(plumber::register_ui, plumber_docs())
#'     }, error = function(e) {
#'       message("Error registering swagger docs. Error: ", e)
#'     })
#'   }
#'
#'   setHook(packageEvent("plumber", "onLoad"), function(...) {
#'     plumber_register_ui()
#'   })
#'   if ("plumber" %in% loadedNamespaces()) {
#'     plumber_register_ui()
#'   }
#' }
#' }
plumber_docs <- function() {
  list(
    name = "swagger",
    index = function(version = "3", ...) {
      swagger_spec(
        api_path = paste0(
          "window.location.origin + ",
          "window.location.pathname.replace(",
            "/\\(",
              "__swagger__\\\\/|",
              "__swagger__\\\\/",
              "index.html|",
              "__docs__\\\\/|",
              "__docs__\\\\/",
              "index.html",
            "\\)$/, ",
            "\"\"",
          ') + "openapi.json"'
        ),
        version = version
      )
    },
    static = function(version = "3", ...) {
      swagger_path(version)
    }
  )
}

library(magrittr)
library(devtools)
library(rvest)

local({

  swagger_ui_version <- "3.33.0"
  to_location <- file.path(
    ".",
    "inst",
    paste0(
      "dist",
      strsplit(swagger_ui_version, ".", fixed = TRUE)[[1]][[1]]
    )
  )

  unlink(to_location, recursive = TRUE)
  dir.create(to_location, recursive = TRUE)

  swagger_release <- paste0("https://unpkg.com/swagger-ui-dist@", swagger_ui_version, "/")
  files <- read_html(swagger_release) %>% html_nodes(".css-xt128v") %>% html_attr("href")

  lapply(files, function(f) {
    # files are large and make CRAN upset
    if (grepl("\\.map$", f)) return()
    # files are not included in html
    if (grepl("es-bundle", f)) return()

    res <- download.file(paste0(swagger_release, f), file.path(to_location, f), mode = "wb")
    if (res != 0L) {
      message(paste("Download of", f, "failed."))
    }
    names(res) <- f
    res == 0
  })

  # shim in rstudio/swagger config settings
  index_html_file <- file.path(to_location, "index.html")
  index_html <- readLines(index_html_file)
  petstore_line <- which(grepl("https://petstore.swagger.io/v2/swagger.json", index_html, fixed = TRUE))
  stopifnot(length(petstore_line) > 0)

  updated_html <- append(
    index_html,
    c(
      "        validatorUrl: null, // disable validation",
      "        // https://github.com/rstudio/swagger/pull/19",
      "        syntaxHighlight: {",
      "          activated: false,",
      "          theme: \"agate\"",
      "        },"
    ),
    after = petstore_line
  )
  writeLines(updated_html, index_html_file)


})

#' swagger: Dynamically Generates Documentation from a Swagger-Compliant API
#'
#' Swagger is a collection of HTML, JavaScript, and CSS assets that
#' dynamically generate beautiful documentation from a Swagger-compliant API.
#'
#' The main purpose of this package is to enable package authors to create
#' APIs that are compatible with \url{https://swagger.io/}
#' and \url{https://www.openapis.org/}.
#'
#' To learn more about Swagger visit: \url{https://swagger.io/swagger-ui/}
#'
"_PACKAGE"

match_version <- function(version = "5") {
  version <- as.character(version)
  match.arg(version, c("3", "4", "5"), several.ok = FALSE)
}


#' Path to Swagger Resources
#'
#' Retrieves the path to swagger resources.
#'
#' @template param-version
#' @examples
#'
#' if (interactive()) {
#'   browseURL(swagger_path())
#' } else {
#'   print(paste("You can explore swagger resources under: ", swagger_path()))
#' }
#'
#' @export
#' @rdname swagger_path
swagger_path <- function(version = "5") {
  system.file(
    paste0("dist", match_version(version)),
    package = "swagger"
  )
}

#' Path to Swagger Index
#'
#' Retrieves the path to the swagger index file.
#'
#' @template param-version
#' @examples
#'
#' if (interactive()) {
#'   browseURL(swagger_index())
#' } else {
#'   print(paste("You can use swagger under: ", swagger_index()))
#' }
#'
#' @export
#' @rdname swagger_index
swagger_index <- function(version = "5") {
  file.path(swagger_path(version = version), "index.html")
}


#' Swagger Index File with OpenAPI Path
#'
#' Produces the content for a \code{index.html} file that will attempt
#' to access a provided API path.
#'
#' @param api_path Path to paste into the an OpenAPI specification file
#' @template param-version
#' @return large string containing the contents of \code{\link{swagger_index}()} with
#'   the appropriate specification path changed to the \code{api_path} value.
#' @examples
#' if (interactive()) {
#'   swagger_spec("https://developer.uspto.gov/ibd-api/swagger.json")
#' }
#' @export
#' @rdname swagger_spec
swagger_spec <- function(
  api_path = "\"http://petstore.swagger.io/v2/swagger.json\"",
  version = "5"
) {

  index_file <- swagger_index(version = version)
  index_txt <- paste0(readLines(index_file), collapse = "\n")

  if (version %in% c("3", "4", "5")) {
    index_txt <-
      sub(
        "\"(http|https)://petstore.swagger.io/v2/swagger.json\"",
        api_path,
        index_txt
      )
  } else {
    stop("swagger_spec not implemented for version: ", version)
  }

  index_txt
}

test_that("match_version accepts only known versions", {
  expect_equal(match_version("3"), "3")
  expect_equal(match_version("4"), "4")
  expect_equal(match_version("5"), "5")

  expect_equal(match_version(3), "3")
  expect_error(match_version("32"))
  expect_error(match_version("23"))
  expect_error(match_version("2"))
})

test_that("swagger_path returns a file path", {
  expect_true(file.exists(swagger_path()))
  expect_true(file.exists(swagger_path("3")))
  expect_true(file.exists(swagger_path(3)))
  expect_true(file.exists(swagger_path("4")))
  expect_true(file.exists(swagger_path("5")))
  expect_equal(swagger_path(5), swagger_path())
  expect_equal(swagger_path("5"), swagger_path())
})


test_that("swagger_index returns a file path", {
  expect_true(file.exists(swagger_index()))
  expect_true(file.exists(swagger_path("3")))
  expect_true(file.exists(swagger_path(3)))
  expect_true(file.exists(swagger_path("4")))
  expect_true(file.exists(swagger_path("5")))
  expect_equal(swagger_index(5), swagger_index())
  expect_equal(swagger_index("5"), swagger_index())
})


test_that("swagger_spec alters the api location", {
  expect_true(
    grepl(
      "\"http://petstore.swagger.io/v2/swagger.json\"", fixed = TRUE,
      swagger_spec()
    )
  )
  expect_true(
    grepl(
      "'specialtestvalue'", fixed = TRUE,
      swagger_spec("'specialtestvalue'")
    )
  )
})

skip_on_cran()

# only test on `"mac"`
skip_on_os(
  setdiff(
    c("windows", "mac", "linux", "solaris"),
    "mac"
  )
)

skip_if_not_installed("jsonlite")

for (dist_version in c("3", "4", "5")) {

  # read from latest major version installed
  swagger_ui_version <- jsonlite::read_json(
    file.path(swagger_path(dist_version), "package.json")
  )$version

  files_location <- swagger::swagger_path(dist_version)
  tmpd <- file.path(tempdir(), paste0("__swagger_rel", dist_version))
  dir.create(tmpd, showWarnings = FALSE)
  on.exit({
    unlink(tmpd)
  }, add = TRUE)

  for (f in dir(files_location)) {
    # do not test shimmed files
    if (f %in% c("index.html")) {
      next
    }
    test_that(paste0(f, " md5 sum in package match swagger version released md5sum"), {
      dld <- download.file(paste0("https://unpkg.com/swagger-ui-dist@", swagger_ui_version, "/", f),
                           file.path(tmpd, f),
                           mode = "wb",
                           quiet = TRUE)
      expect_equivalent(tools::md5sum(file.path(files_location, f)),
                        tools::md5sum(file.path(tmpd, f)),
                        info = paste0("file: ", f))
    })
  }

}

#!/usr/bin/env bash

echo "Announce changes to the world!"

VERSION=$(tomlq -r '.package.version' Cargo.toml)
echo "Version: $VERSION"

# Send announcement to a standalone test Slack channel.
docker run \
   --rm \
  -v $PWD:/announcer \
  metaswitch/announcer:2.3.0 \
    announce \
    --slackhook $SLACK_HOOK \
    --changelogversion $VERSION \
    --changelogfile /announcer/CHANGELOG.md \
    --projectname announcer \
    --username travis-announcer \
    --iconemoji party_parrot

#!/usr/bin/env bash
# Updated the changelog for a new release
set -eou pipefail

version=$1
date=$(date +%Y-%m-%d)


sed -i "s/^version = \".\+\"$/version = \"$version\"/" Cargo.toml

sed -i "s/## \[Unreleased\]/## [Unreleased]\n### Added\n\n### Changed\n\n### Removed\n\n## [$version] - $date/" CHANGELOG.md

sed -i "s#\[Unreleased\]: https://github.com/Metaswitch/swagger-rs/compare/\(.*\)...HEAD#[Unreleased]: https://github.com/Metaswitch/swagger-rs/compare/$version...HEAD\n[$version]: https://github.com/Metaswitch/swagger-rs/compare/\1...$version#" CHANGELOG.md

echo "Now, delete any empty headers from $version in CHANGELOG.md"

# Contributing to `swagger-rs`

Thanks for your interest - we gratefully welcome contributions.

Questions can be asked in [issues](https://github.com/Metaswitch/swagger-rs/issues).

To help us help you get pull requests merged quickly and smoothly, open an issue before submitted large changes. Please keep the contents of pull requests and commits short. Commit messages should include the intent of the commit. Pull requests should add an entry to [CHANGELOG.md].

Contributions that add/improve tests are awesome. Please add tests for every change.

`swagger-rs` uses [`rustfmt`](https://github.com/rust-lang-nursery/rustfmt) for formatting and [`clippy`](https://github.com/rust-lang-nursery/rust-clippy) for linting. See .travis.yml for the versions we use.

## Testing against openapi-generator

If you are making a non-trivial change, please open a simultaneous PR against openapi-generator. This will allow the openapi-generator CI pipeline to verify that your change is compatible.

You will need to update `modules/openapi-generator/src/main/resources/rust-server/Cargo.mustache` as follows:

```toml
swagger = { git = "https://github.com/foo/swagger-rs.git", branch = "bar"}
```

## Conduct

In all `swagger-rs`-related forums, we follow the [Swagger Codegen Code of Conduct](https://github.com/swagger-api/swagger-codegen/blob/master/CODE_OF_CONDUCT.md). For escalation or moderation issues please contact Benjamin (mailto:benjamin.gill@metaswitch.com) instead of the swagger-api moderation team.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/paths.R
\name{swagger_spec}
\alias{swagger_spec}
\title{Swagger Index File with OpenAPI Path}
\usage{
swagger_spec(
  api_path = "\\"http://petstore.swagger.io/v2/swagger.json\\"",
  version = "5"
)
}
\arguments{
\item{api_path}{Path to paste into the an OpenAPI specification file}

\item{version}{Major version number to be used for Swagger UI.  Currently version \code{"3"} is compatible with OpenAPI spec 2.0, 3.0.}
}
\value{
large string containing the contents of \code{\link{swagger_index}()} with
  the appropriate specification path changed to the \code{api_path} value.
}
\description{
Produces the content for a \code{index.html} file that will attempt
to access a provided API path.
}
\examples{
if (interactive()) {
  swagger_spec("https://developer.uspto.gov/ibd-api/swagger.json")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/paths.R
\name{swagger_path}
\alias{swagger_path}
\title{Path to Swagger Resources}
\usage{
swagger_path(version = "5")
}
\arguments{
\item{version}{Major version number to be used for Swagger UI.  Currently version \code{"3"} is compatible with OpenAPI spec 2.0, 3.0.}
}
\description{
Retrieves the path to swagger resources.
}
\examples{

if (interactive()) {
  browseURL(swagger_path())
} else {
  print(paste("You can explore swagger resources under: ", swagger_path()))
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plumber.R
\name{plumber_docs}
\alias{plumber_docs}
\title{Plumber `register_doc()` information}
\usage{
plumber_docs()
}
\description{
Normally documentation is registered in the `.onLoad()` method of the package.
To avoid a circular dependency with `swagger` when `plumber` are starting up,
`plumber` must retrieve this information manually on it's startup.
}
\details{
See the examples for how documentation should regularly be registered.
}
\examples{
\dontrun{
## Suggested setup for other packages trying to register visual docs for plumber
.onLoad <- function(...) {
  plumber_register_ui <- function() {
    tryCatch({
      do.call(plumber::register_ui, plumber_docs())
    }, error = function(e) {
      message("Error registering swagger docs. Error: ", e)
    })
  }

  setHook(packageEvent("plumber", "onLoad"), function(...) {
    plumber_register_ui()
  })
  if ("plumber" \%in\% loadedNamespaces()) {
    plumber_register_ui()
  }
}
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/swagger.R
\docType{package}
\name{swagger-package}
\alias{swagger}
\alias{swagger-package}
\title{swagger: Dynamically Generates Documentation from a Swagger-Compliant API}
\description{
Swagger is a collection of HTML, JavaScript, and CSS assets that
dynamically generate beautiful documentation from a Swagger-compliant API.
}
\details{
The main purpose of this package is to enable package authors to create
APIs that are compatible with \url{https://swagger.io/}
and \url{https://www.openapis.org/}.

To learn more about Swagger visit: \url{https://swagger.io/swagger-ui/}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://rstudio.github.io/swagger/}
  \item \url{https://github.com/rstudio/swagger}
  \item Report bugs at \url{https://github.com/rstudio/swagger/issues}
}

}
\author{
\strong{Maintainer}: Bruno Tremblay \email{cran@neoxone.com} [contributor]

Authors:
\itemize{
  \item Barret Schloerke \email{barret@rstudio.com} (\href{https://orcid.org/0000-0001-9986-114X}{ORCID})
  \item Javier Luraschi \email{javier@rstudio.com}
  \item  SmartBear Software [copyright holder]
}

Other contributors:
\itemize{
  \item  RStudio [copyright holder]
}

}
